//+-----------------------------------------------------------------------+
//| Volatility Quality                                                    |
//| Original 10Point 3.mq4 Copyright  2005, Alejandro Galindo            |
//| http://elCactus.com                                                   |
//|                                                                       |
//|                                                                       |
//|                                                                       |
//|                                                                       |
//|                                                                       |
//+-----------------------------------------------------------------------+

#property copyright "Copyright  2005, Alejandro Galindo"
#property link      "http://elCactus.com"


extern int    Magic             = 123987;  // Magic number for the orders placed
extern double Lots              = 0.01;    // First order will be for this lots
extern double trailingstart     = 50;      // profit in pips required to enable the trailing stop
extern double trailingstop      = 0;       // trailing stop
extern double trailingprofit    = 50;      // trailing profit
extern double trailingstep      = 0;       // margin allowed to the market to enable the trailing stop
extern double breakevengain     = 0;       // gain in pips required to enable the break even
extern double breakeven         = 50;      // break even

extern int    MaxTrades         = 7;       // Maximum number of orders to open
extern bool   DynamicPips       = true;    // Use ATR for Pips between orders in progress
extern int    StorePips         = 10;      // above zero will average with ATR value (Pips)
extern bool   DynamicTP         = true;    // Use ATR for pips of TakeProfit
extern double StoreTP           = 15;       // above zero will average with ATR value (TakeProfit)
extern bool   DynamicSL         = true;    // Use ATR for pips of InitialStop
extern double StoreSL           = 0;       // above zero will average with ATR value (InitialStop)
extern int    sltpatrtf         = 5;       // timeframe used with dynamic sl and tp ie valueatr
extern int    sltpatrperiod     = 60;      // period used with dynamic sl and tp ie valueatr
extern int    pipstepatrtf      = 0;       // timeframe used with dynamic pipstep
extern int    pipstepatrperiod  = 5;       // dynamic pip step period
extern int    slatrtf           = 0;       // dynamic stoploss atr timeframe
extern int    slatrperiod       = 30;      // dynamic stoploss atr period
extern int    tpatrtf           = 0;       // dynamic take profit atr timeframe
extern int    tpatrperiod       = 60;      // dynamic take profit atr period

extern string AccountType_is    = " 0=normal,1=mini,2=micro";
extern int    AccountType       = 2;         
extern int    mm                = 0;       // if 1, the lots size will increase based on account size
extern int    risk              = 12;      // risk to calculate the lots size (only if mm is enabled)
extern double LotMultiplier     = 1.75;
extern bool   SpreadProtection  = True;    // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance      = 5;       // value in pips over normal spread to activate the SpreadProtection.

extern string timefilter_is     = "Time Filter";
extern int    summergmtshift    = 2;       // gmt offset of the broker
extern int    wintergmtshift    = 1;       // gmt offset of the broker
extern bool   mondayfilter      = false;   // enable special time filter on friday
extern int    mondayhour        = 12;      // stop to trade after this hour
extern int    mondayminute      = 0;       // minutes of the friday hour
extern bool   weekfilter        = false;   // enable time filter
extern int    starthour         = 5;       // start hour to trade after this hour
extern int    startminute       = 0;       // minutes of the start hour
extern int    endhour           = 20;      // stop to trade after this hour
extern int    endminute         = 0;       // minutes of the start hour
extern bool   tradesunday       = true;    // trade on sunday
extern bool   fridayfilter      = true;    // enable special time filter on friday
extern int    fridayhour        = 21;      // stop to trade after this hour
extern int    fridayminute      = 0;       // minutes of the friday hour

extern string S1                ="Entry Settings";
extern int    PriceSmoothing    = 35;
extern int    PriceSmoothingMet = MODE_LWMA;
extern int    MA1Period         = 5;
extern int    MA2Period         = 200;
extern int    Filter            = 5;
extern int    shift             = 1;
                                            

                                

int    slippage=5,cnt;
int    PreviousOpenOrders=0;
int    mode=0,DontContinue, myOrderType=0;
int    nstarthour,nendhour,nfridayhour,nmondayhour,gmtshift,tradetime;
int    dg;
int    ValueATR=10;
int    Pips=10;   
int    InitialStop=10;
int    TakeProfit=10;

double sl=0, tp=0;
double LastPrice=0;
double lotsi=0, mylotsi=0;
double Spread,WorstSpread,NormalSpread;
double win[14],sum[14];
double point = 0;
double pipMultiplier = 1;

string text="",text2="";
string time="";
string istarthour,istartminute,iendhour,iendminute,ifridayhour,ifridayminute,imondayhour,imondayminute;

bool   ContinueOpening=True;

datetime t0,t1,tstart,tend,tfriday,tmonday;

int init()
{
   t0=Time[0];
   t1=Time[0];

   sum[2012-1999]=D'2012.03.28 02:00:00';win[2012-1999]=D'2012.10.31 03:00:00';
   sum[2011-1999]=D'2011.03.29 02:00:00';win[2011-1999]=D'2011.10.25 03:00:00';
   sum[2010-1999]=D'2010.03.30 02:00:00';win[2010-1999]=D'2010.10.26 03:00:00';
   sum[2009-1999]=D'2009.03.29 02:00:00';win[2009-1999]=D'2009.10.25 03:00:00';
   sum[2008-1999]=D'2008.03.30 02:00:00';win[2008-1999]=D'2008.10.26 03:00:00';
   sum[2007-1999]=D'2007.03.25 02:00:00';win[2007-1999]=D'2007.10.28 03:00:00';
   sum[2006-1999]=D'2006.03.26 02:00:00';win[2006-1999]=D'2006.10.29 03:00:00';
   sum[2005-1999]=D'2005.03.27 02:00:00';win[2005-1999]=D'2005.10.30 03:00:00';
   sum[2004-1999]=D'2004.03.28 02:00:00';win[2004-1999]=D'2004.10.31 03:00:00';
   sum[2003-1999]=D'2003.03.30 02:00:00';win[2003-1999]=D'2003.10.26 03:00:00';
   sum[2002-1999]=D'2002.03.31 02:00:00';win[2002-1999]=D'2002.10.27 03:00:00';
   sum[2001-1999]=D'2001.03.25 02:00:00';win[2001-1999]=D'2001.10.28 03:00:00';
   sum[2000-1999]=D'2000.03.26 02:00:00';win[2000-1999]=D'2000.10.29 03:00:00';
   sum[1999-1999]=D'1999.03.28 02:00:00';win[1999-1999]=D'1999.10.31 03:00:00';
   
   dg=Digits;
   if(dg==3 || dg==5){point=Point*10;pipMultiplier=10;}else{point=Point;pipMultiplier=1;}
   
   
   NormalSpread=MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,dg%2);


return(0);
}

int deinit(){return(0);}

int checktime(){
    if(TimeCurrent()<win[TimeYear(TimeCurrent())-1999] && TimeCurrent()>sum[TimeYear(TimeCurrent())-1999])gmtshift=summergmtshift;
    else gmtshift=wintergmtshift;
   
    string svrdate = Year()+"."+Month()+"."+Day();

    if(mondayfilter){
      nmondayhour=mondayhour+(gmtshift);if(nmondayhour>23)nmondayhour=nmondayhour-24;
      if(nmondayhour<10)imondayhour="0"+nmondayhour;
      if(nmondayhour>9)imondayhour=nmondayhour;
      if(mondayminute<10)imondayminute="0"+mondayminute;
      if(mondayminute>9)imondayminute=mondayminute;
      tmonday=StrToTime(svrdate+" "+imondayhour+":"+imondayminute);
    }
    if(weekfilter){
      nstarthour=starthour+(gmtshift);if(nstarthour>23)nstarthour=nstarthour-24;
      if(nstarthour<10)istarthour="0"+nstarthour;
      if(nstarthour>9)istarthour=nstarthour;
      if(startminute<10)istartminute="0"+startminute;
      if(startminute>9)istartminute=startminute;
      tstart=StrToTime(svrdate+" "+istarthour+":"+istartminute);

      nendhour=endhour+(gmtshift);if(nendhour>23)nendhour=nendhour-24;
      if(endhour<10)iendhour="0"+nendhour;
      if(endhour>9)iendhour=nendhour;
      if(endminute<10)iendminute="0"+endminute;
      if(endminute>9)iendminute=endminute;
      tend=StrToTime(svrdate+" "+iendhour+":"+iendminute);
    }
    if(fridayfilter){
      nfridayhour=fridayhour+(gmtshift);if(nfridayhour>23)nfridayhour=nfridayhour-24;
      if(nfridayhour<10)ifridayhour="0"+nfridayhour;
      if(nfridayhour>9)ifridayhour=nfridayhour;
      if(fridayminute<10)ifridayminute="0"+fridayminute;
      if(fridayminute>9)ifridayminute=fridayminute;
      tfriday=StrToTime(svrdate+" "+ifridayhour+":"+ifridayminute);
    }
    if(nstarthour>nendhour && TimeCurrent()<tstart && TimeCurrent()>tend)time="DONT TRADE";else time="TRADE";
    if((weekfilter && (nstarthour<=nendhour && TimeCurrent()<tstart || TimeCurrent()>tend) || (nstarthour>nendhour && TimeCurrent()<tstart && TimeCurrent()>tend))
    || (tradesunday==false && DayOfWeek()==0) || (fridayfilter && DayOfWeek()==5 && TimeCurrent()>tfriday) || (mondayfilter && DayOfWeek()==1 && TimeCurrent()<tmonday))return(0);
    return(1);
    }


int start()
  {
    checktime();
    if(Seconds()==30) {
    ValueATR = iATR(NULL,sltpatrtf,sltpatrperiod,shift)/point;         // SL & TP modifier
     
    if (DynamicPips) {
    Pips = iATR(NULL,pipstepatrtf,pipstepatrperiod,shift)/point;
    if (StorePips>0) { Pips = (StorePips + Pips) / 2;}                  // average Dynamic and user Pips
    if (Pips < 5) Pips=5;                                               // set Pips to minimum of 5
    } 
    else Pips=StorePips;
       
    if (DynamicSL)  {
    InitialStop = iATR(NULL,slatrtf,slatrperiod,shift)/point+ValueATR; // add fast small ATR value
    if (StoreSL>0) { InitialStop = (StoreSL + InitialStop) /2; }       // average Dynamic and user StopLoss
    } 
    else InitialStop=StoreSL;
   
    if (DynamicTP)  {
    TakeProfit = iATR(NULL,tpatrtf,tpatrperiod,shift)/point-ValueATR;  // subtract small fast ATR value
    if (StoreTP>0) { TakeProfit = (StoreTP + TakeProfit) /2; }         // average Dynamic and user TakeProfit
    }
    else TakeProfit=StoreTP;
    }  

  
    
   if(breakevengain>0)movebreakeven(breakevengain,breakeven);
   if(trailingstop>0)movetrailingstop(trailingstart,trailingstop);
   if(trailingprofit>0)movetrailingprofit(trailingstart,trailingprofit);
   if (Spread>WorstSpread) WorstSpread=Spread;
   if (SpreadProtection && Spread>NormalSpread+PipTolerance) DontContinue=1; else DontContinue=0;
   
   
   
   if (AccountType==0)
   {
	 if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000); }
	 else { lotsi=Lots; }
   } 
   
   if (AccountType==1)
   {  // then is mini
    if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/10; }
	 else { lotsi=Lots; }
   }
   
   if (AccountType==2)
   {
    if (mm!=0) { lotsi=MathCeil(AccountBalance()*risk/10000)/100; }
    else { lotsi=Lots; }
   }

   if (lotsi<0.01)lotsi=0.01;
   if (lotsi>100) lotsi=100; 
   
   
   
   int OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	  	  OpenOrders++;
	  }
   }     
   
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(), slippage*point,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*point,Red); }
			return(0);
		 }
	  }
   }

   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }

   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY)  { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
			
         
		 }
	  }
   }

   if (OpenOrders<1) 
   { 
     
	myOrderType=OpenOrdersBasedOnVQ(); 
	               
   }

      if (!IsTesting()) 
      {
	     if (myOrderType==3) { text="No conditions to open trades"; }
	     else { text="                         "; }
	     Comment("LastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\n",text2,"\nLots=",lotsi,"\n",text,"\n",time);
      }
      if (myOrderType==1 && ContinueOpening && DontContinue==0 && checktime()) 
      {	
	     if ((Bid-LastPrice)>=Pips*point || OpenOrders<1) 
	     {		
		    double SellPrice=Bid;				
		           LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*point; }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*point + (MaxTrades-OpenOrders)*Pips*point,dg);  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*LotMultiplier,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage*point,sl,tp,"vq sell",Magic,0,Red);		    		    
		    return(0);
	     }
      }
      if (myOrderType==2 && ContinueOpening && DontContinue==0 && checktime()) 
      {
	     if ((LastPrice-Ask)>=Pips*point || OpenOrders<1) 
	     {		
		    double BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*point; }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*point - (MaxTrades-OpenOrders)*Pips*point,dg); }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*LotMultiplier,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage*point,sl,tp,"vq buy",Magic,0,Blue);		    
		    return(0);
	     }
      }   

   return(0);
  }
  

void movebreakeven(double breakevengain,double breakeven){
   RefreshRates();
   if(OrdersTotal()>0){
      for(int i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble((Bid-OrderOpenPrice()),dg)>=NormalizeDouble(breakevengain*point+Pips*point,dg)){
                  if((NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),dg)<NormalizeDouble(breakeven*point,dg)) || OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+breakeven*point,dg),OrderTakeProfit(),0,Blue);
                     return(0);
                  }
               }
            }
            else{
               if(NormalizeDouble((OrderOpenPrice()-Ask),dg)>=NormalizeDouble(breakevengain*point+Pips*point,dg)){
                  if((NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),dg)<NormalizeDouble(breakeven*point,dg)) || OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-breakeven*point,dg),OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}

//|---------trailingstop

void movetrailingstop(double trailingstart,double trailingstop){
   RefreshRates();
   if(OrdersTotal()>0){
      for(int i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(Ask,dg)>NormalizeDouble(OrderOpenPrice()+trailingstart*point+Pips*point,dg)
               && NormalizeDouble(OrderStopLoss(),dg)<NormalizeDouble(Bid-(trailingstop+trailingstep)*point,dg)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-trailingstop*point,dg),OrderTakeProfit(),0,Blue);
                  return(0);
               }
            }
            else{
               if(NormalizeDouble(Bid,dg)<NormalizeDouble(OrderOpenPrice()-trailingstart*point+Pips*point,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)>(NormalizeDouble(Ask+(trailingstop+trailingstep)*point,dg))) || (OrderStopLoss()==0)){                 
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+trailingstop*point,dg),OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
      }
   }
}

//|---------trailingprofit

void movetrailingprofit(double trailingstart,double trailingprofit){
   RefreshRates();
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol()&& OrderMagicNumber()==Magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(Bid-OrderOpenPrice(),dg)<=NormalizeDouble((-1)*trailingstart*point+Pips*point,dg)){
                  if(NormalizeDouble(OrderTakeProfit(),dg)>NormalizeDouble(Bid+(trailingprofit+trailingstep)*point,dg) || NormalizeDouble(OrderTakeProfit(),dg)==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(Bid+trailingprofit*point,dg),0,Blue);
                  }
               }
            }
            if(OrderType()==OP_SELL){
               if(NormalizeDouble(OrderOpenPrice()-Ask,dg)<=NormalizeDouble((-1)*trailingstart*point+Pips*point,dg)){
                  if(NormalizeDouble(OrderTakeProfit(),dg)<NormalizeDouble(Ask-(trailingprofit+trailingstep)*point,dg)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(Ask-trailingprofit*point,dg),0,Red);
                  }
               }
            }
         }
      }
   }
}

int OpenOrdersBasedOnVQ()
{
   int myOrderType=3;
	double trendNow = iCustom(NULL,0,"VQ-nrp",PriceSmoothing,PriceSmoothingMet,MA1Period,MA2Period,Filter,6,shift);
   double trendPrv = iCustom(NULL,0,"VQ-nrp",PriceSmoothing,PriceSmoothingMet,MA1Period,MA2Period,Filter,6,shift+1);
   
   if (trendNow!=trendPrv) // trend change
   if (trendNow==1)
   {
   myOrderType = 2;   // trend is up
   }
   else
   {
   myOrderType = 1;   // trend is down
   }  
 
	return(myOrderType);
}

